$fn=80;
FT3Top();
FT3Box();
FT3Bottom();
Pillar();

function cot(x)=1/tan(x);

module MakeCap() {
    translate([0,0,0]) cylinder(d=4,4);
    rotate_extrude(convexity=10)
    translate([4/2,2,0]) intersection(){circle(r=2); square(2);} 
}
module tapered_cuboid(w, l, h, taper) {
	ho=taper; hw=w-taper; hl=l-taper;
	polyhedron( points=[
	 [0,0,0], [ho, ho, h], [hw, ho, h], [w,0,0],
	 [0,l,0], [ho, hl, h], [hw, hl, h], [w,l,0]],
    faces = [
	 [0,1,2],[2,3,0],[3,2,6],[6,7,3],[7,6,5],[5,4,7],[4,5,1],[1,0,4],
	 [1,5,2],[2,5,6],[4,0,3],[7,4,3],]);
}
module Hexagone(cle,h){
	angle = 360/6; // 6 Eck
	cote = cle*cot(angle);
	echo(angle, cot(angle), cote);
	echo(acos(.6));
   union()	{
	rotate([0,0,0])      cube([cle,cote,h],center=true);
	rotate([0,0,angle])	 cube([cle,cote,h],center=true);
	rotate([0,0,2*angle])cube([cle,cote,h],center=true);
}  }
module FT3Top() {difference() {
  union() {
   translate([ 52,29,0])  cylinder(d=8,4);
   translate([-52,29,0])  cylinder(d=8,4);
   translate([52,-29,0])  cylinder(d=8,4);
   translate([-52,-29,0]) cylinder(d=8,4);
   translate([0,0,2]) cube([112,58,4],center=true); 
   translate([0,0,2]) cube([104,66,4],center=true); 
  }
  rotate([180])translate ([-55.5,-32.5,-5])tapered_cuboid(111,65,3,5);
  translate([17,0,0]) cylinder(d=6,5); // Button
}
 difference()  {union(){
  difference() {union(){
   translate([17,0,2])  cube([13.5,48,4],center=true); 
   translate([15,-10.5,2])rotate([0,0,10]) cube([14,24,4],center=true); 
   translate([15,10.5,2]) rotate([0,0,-10])cube([14,24,4],center=true); 
   translate([19,10.5,2]) rotate([0,0,10]) cube([14,24,4],center=true); 
   translate([19,-10.5,2])rotate([0,0,-10])cube([14,24,4],center=true); 
  }
  translate([17,0,5])  cube([11.5,46,4],center=true); 
  translate([15,-10.4,5])rotate([0,0,10]) cube([12,23.5,4],center=true); 
  translate([15,10.4,5]) rotate([0,0,-10])cube([12,23.5,4],center=true); 
  translate([19,10.4,5]) rotate([0,0,10]) cube([12,23.5,4],center=true); 
  translate([19,-10.4,5])rotate([0,0,-10])cube([12,23.5,4],center=true);
 }
  translate([17, 23,0]) cube([2,8,4]); 
  translate([17,-31,0]) cube([2,8,4]); 
  translate([17, 0, 0]) cylinder(d=18,4);
  translate([17,0,4.5]) rotate([0,0,20])Hexagone(cle=14,h=2);
  translate([-42,0,2])  cube([8,48,4],center=true); // Label 
  for (i=[-50:1.7:17]) {  
   translate([i,0,1.5]) rotate([0,45]) cube([2,62,2],center=true);}
}
  translate([17,0,0])   cylinder(d=6,9); // Button
  translate([-42,0,3])  cube([6,46,2],center=true); // Label
 }
 translate ([-44,21,2]) rotate([0,0,270]) {
  linear_extrude(height=1.5) text("TRANSMITTER", font="Arial Black",
  size=3.7);}
}

module FT3Box() {translate([0,0,-30])
    difference() {roundedBox(); counterBore();}
  module roundedBox(w=112, l=66, ht=30, ra=4, th=2.5) {
    difference() {
     roundedBoxBlank(w, l, ht, ra); translate([0,0,-1])
     roundedBoxBlank(w-th*2, l-th*2, ht, ra-th);}
    }
   module roundedBoxBlank(w,l,ht,ra) {
    hull() {
     translate([ra-w/2, ra-l/2,0]) cylinder(r=ra,ht);
     translate([w/2-ra, ra-l/2,0]) cylinder(r=ra,ht);
     translate([ra-w/2, l/2-ra,0]) cylinder(r=ra,ht);
     translate([w/2-ra, l/2-ra,0]) cylinder(r=ra,ht);
   }}
  module counterBore() {     
   translate([17,0,28])   cylinder(d=6,3); // Button
   translate([35,-32,18]) cube([20,4,13],center=true); // Schalter
   translate([53, 25,20]) rotate([0,90]) cylinder(d=7,4);// Antenne
   translate([-56,25,20]) rotate([0,90]) cylinder(d=7,d2=3,2.5);
} }
module FT3Bottom() {rotate([180])translate([0,0,28])
  difference() { union() {
   translate([ 52,29,0])  {MakeCap(); cylinder(d=8,2);}
   translate([-52,29,0])  {MakeCap(); cylinder(d=8,2);}
   translate([52,-29,0])  {MakeCap(); cylinder(d=8,2);}
   translate([-52,-29,0]) {MakeCap(); cylinder(d=8,2);}
   translate([0,0,2]) cube([108,60,4],center=true); 
   translate([0,0,2]) cube([106,62,4],center=true); 
   rotate([0,90]) {translate([-2,31,-52]) cylinder(d=4,104);
    translate([-2,-31,-52]) cylinder(d=4,104); }
   rotate([90]) {translate([-54,2,-29]) cylinder(d=4,58);
    translate([54,2,-29]) cylinder(d=4,58); }
   translate ([-45,21,4]) rotate([0,0,270]) {
   linear_extrude(height=.5) text("TOKYO      JAPAN",
   font="Arial Black", size=3);}
  }
   translate([0,0,1]) cube([114,68,2],center=true);}
}
module Pillar() {
  translate([0,0,-3])cylinder(d=7,d2=10,2);
  translate([0,0,-30])difference(){cylinder(d=7,27);cylinder(d=2,27);}
}